﻿#include "ModuleReader.h"
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>

void OnTagRead(int hReader, TAGINFO *tag, void* cookie)
{
	int i;
	printf("epc:");
 	for(i = 0; i < tag->Epclen; ++i)
 		printf("%02X", tag->EpcId[i]);
 	printf("\n");
}

void OnReadingError(int hReader, READER_ERR errcode, void* cookie)
{
	char rdrip[50];
	int internalcode;
	char *errdes;
	GetReaderAddress(hReader, rdrip);
	GetLastDetailError(hReader, &internalcode, &errdes);
	printf("reader %s error:%d, info:%s", rdrip, internalcode, errdes);
	CloseReader(hReader);
	/////
	//可在此处重新打开读写器并继续盘存标签，可尝试多次，如果多次打开读写器不成功可放弃。
	//////
}

int main(int argc, char *argv[])
{
	int hreader;
	Inv_Potls_ST invpotls;
	READER_ERR err;
	int ants[] = {1};
 	AntPowerConf antpwrconf;
 
	if (argc != 2)
	{
		printf("cmdline err\n");
		return -1;
	}
  err = InitReader_Notype(&hreader, argv[1], 1);
  if (err != 0)
  {
    printf("init reader err :%d\n", err);
    return -1;
  }
  printf("init UHF reader-%s OK\n", argv[1]);
  invpotls.potlcnt = 1;
  invpotls.potls[0].potl = SL_TAG_PROTOCOL_GEN2;
  invpotls.potls[0].weight = 30;
  err = ParamSet(hreader, MTR_PARAM_TAG_INVPOTL, &invpotls);
 
  antpwrconf.antcnt = 1;
  antpwrconf.Powers[0].antid = 1;
  antpwrconf.Powers[0].readPower = 2500;
  antpwrconf.Powers[0].writePower = 2500;
  
	
	if (ParamSet(hreader, MTR_PARAM_RF_ANTPOWER, &antpwrconf) != MT_OK_ERR)
	{
		printf("ParamSet MTR_PARAM_RF_ANTPOWER err\n");
		return -1;
	}
	else
	printf("ParamSet MTR_PARAM_RF_ANTPOWER OK\n");

	OnReadingErrorBlock reblk;
	reblk.handler = OnReadingError;
	reblk.cookie = NULL;
	SetReadingErrorHandler(hreader, reblk);
	
	OnTagReadBlock trblk;
	trblk.handler = OnTagRead;
	trblk.cookie = NULL;
	SetTagReadHandler(hreader, trblk);

	BackReadOption BROption;
	memset(&BROption, 0, sizeof(BackReadOption));
	BROption.IsFastRead = 0;
	BROption.ReadDuration = 250;
  	BROption.ReadInterval = 0;
 	err = StartReading(hreader, ants, 1, &BROption);
	if (err == MT_OK_ERR)
		printf("ResumeReading successfully\n");
	else
	{
		printf("ResumeReading failed err:%d\n", err);
		return -1;
	}

  	while (1)
  	{
		usleep(5000000);
		StopReading(hreader);
		break;
	}
 	CloseReader(hreader);
	return 0;
}
